Subject: Re: [RFC/PATCH] git-instaweb: Add support for running gitweb via 'plackup'

From: Jakub Narebski <[email-masked]>
Date: Wed, 19 May 2010 22:52:46 +0200

On Wed, 19 May 2010, Jakub Narebski wrote:

> ---
[...]
> RFC is because when when running
> 
>   $ ./git-instaweb --httpd=plackup --browser=lynx
> 
> I get the following error
> 
>   Looking up 127.0.0.1:1234
>   Making HTTP connection to 127.0.0.1:1234
>   Alert!: Unable to connect to remote host.
> 
>   lynx: Can't access startfile http://127.0.0.1:1234/
>   http://127.0.0.1:1234
> 
> But running 'lynx http://127.0.0.1:1234/' after this works correctly
> without problems.  Running './.git/gitweb/gitweb.psgi' doesn't cause
> any problems either.  WTF?

I think I know what might be happening here.  The plackup / Plack::Runner
needs some time to setup and start running HTTP::Server::PSGI based web
server.  When it is ready to serve requests (web pages), it prints to stderr

  <server>: Accepting connections at http://<host>:<port>/

In the case of .git/gitweb/gitweb.psgi script generated by git-instaweb it
is:

  HTTP::Server::PSGI: Accepting connections at http://0:1234/

But plackup / Plack::Runner is run in background (HTTP::Server::PSGI does
not support '--daemonize'), and most probably the web browser is started
before web server is not ready.

Do you have any idea on how to synchronize those two processes, the web
server and the web client (web browser), so that web browser is run only
after web server prints that it is ready to accept connection?

TIA.

> @@ -83,9 +90,9 @@ start_httpd () {
>  
>  	# don't quote $full_httpd, there can be arguments to it (-f)
>  	case "$httpd" in
> -	*mongoose*)
> -		#The mongoose server doesn't have a daemon mode so we'll have to fork it
> -		$full_httpd "$fqgitdir/gitweb/httpd.conf" &
> +	*mongoose*|*plackup*)
> +		#The mongoose server and plackup don't have a daemon mode so we'll have to fork it
> +		$full_httpd "$fqgitdir/gitweb/httpd.conf" 2>"$fqgitdir/error_log" &
>  		#Save the pid before doing anything else (we'll print it later)
>  		pid=$!
>  

-- 
Jakub Narebski
Poland